# -*- coding: UTF-8 -*-
#
#      cons.py
#      
#      Copyright 2009-2010
#      Giuseppe Penone <giuspen@gmail.com>,
#      Chris Camacho (chris_c) <chris_camacho@yahoo.com>.
#      
#      plus many thanks to  http://tronche.com/gui/x/xlib/
#                      and  http://tripie.sweb.cz/utils/wmctrl/
#
#      This program is free software; you can redistribute it and/or modify
#      it under the terms of the GNU General Public License as published by
#      the Free Software Foundation; either version 2 of the License, or
#      (at your option) any later version.
#      
#      This program is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.
#      
#      You should have received a copy of the GNU General Public License
#      along with this program; if not, write to the Free Software
#      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#      MA 02110-1301, USA.

import gtk, os


APP_NAME = "x-tile"
VERSION = "1.5.2"
LOCALE_PATH = "/usr/share/locale/"

if os.path.isdir('glade'):
   GLADE_PATH = "glade/"
   ICON_PLACE = "linux/x-tile.svg"
else:
   GLADE_PATH = "/usr/share/x-tile/glade/"
   ICON_PLACE = "/usr/share/pixmaps/x-tile.svg"

AVAILABLE_LANGS = ['default', 'de', 'en', 'fr', 'it', 'ru', 'zh_TW']

APPLET_DESC = _("X Tile\nTile The Windows Upon Your Desktop")

ON_OFF = {"True":_("ON"), "False":_("OFF")}

HY_ADJ = 0.76
HEIGHT_ADJ = 30
WIDTH_ADJ = 2
OVERRIDE_1 = 0
OVERRIDE_2 = 0
X1 = 0
Y1 = 0
W1 = 10
H1 = 10
X2 = 0
Y2 = 0
W2 = 10
H2 = 10

TILING_BREAK = 0.1

STATIC_WINS_BLACKLIST = ["x-nautilus-desktop"]

ICONS_SIZE = {1: gtk.ICON_SIZE_MENU, 2: gtk.ICON_SIZE_SMALL_TOOLBAR, 3: gtk.ICON_SIZE_LARGE_TOOLBAR,
              4: gtk.ICON_SIZE_DND, 5: gtk.ICON_SIZE_DIALOG}

ICONS_FILENAMES = [(GLADE_PATH + 'tile-vertically.svg', 'Tile Vertically'),
                   (GLADE_PATH + 'tile-horizontally.svg', 'Tile Horizontally'),
                   (GLADE_PATH + 'tile-quad.svg', 'Tile Quad'),
                   (GLADE_PATH + 'tile-triangle-up.svg', 'Tile Triangle Up'),
                   (GLADE_PATH + 'tile-triangle-down.svg', 'Tile Triangle Down'),
                   (GLADE_PATH + 'tile-triangle-left.svg', 'Tile Triangle Left'),
                   (GLADE_PATH + 'tile-triangle-right.svg', 'Tile Triangle Right'),
                   (GLADE_PATH + 'reload-windows-list.svg', 'Reload Windows List'),
                   (GLADE_PATH + 'maximize-checked-windows.svg', 'Maximize Windows'),
                   (GLADE_PATH + 'unmaximize-checked-windows.svg', 'Unmaximize Windows'),
                   (GLADE_PATH + 'close-checked-windows.svg', 'Close Windows'),
                   (GLADE_PATH + 'toolbar.png', 'Toolbar'),
                   (GLADE_PATH + 'vbuttonbox.png', 'VButtons'),
                   (GLADE_PATH + 'help-contents.svg', 'Help Contents'),
                   (GLADE_PATH + 'checkbox_checked.svg', 'Select All'),
                   (GLADE_PATH + 'checkbox_unchecked.svg', 'Deselect All')]

GCONF_EXIT_AFTER_TILE = "/apps/x-tile/%s/exit_after_tile"
GCONF_ONLY_CURR_DESK = "/apps/x-tile/%s/only_curr_desk"
GCONF_TOOLBAR_ICON_SIZE = "/apps/x-tile/%s/toolbar_icon_size"
GCONF_PROCESS_BLACKLIST = "/apps/x-tile/%s/process_blacklist"
GCONF_WIN_SIZE_W = "/apps/x-tile/%s/win_size_w"
GCONF_WIN_SIZE_H = "/apps/x-tile/%s/win_size_h"
GCONF_WIN_POSITION_X = "/apps/x-tile/%s/win_position_x"
GCONF_WIN_POSITION_Y = "/apps/x-tile/%s/win_position_y"
GCONF_SHOW_TOOLBAR = "/apps/x-tile/%s/show_toolbar"
GCONF_SHOW_VBUTTONS = "/apps/x-tile/%s/show_vbuttons"
GCONF_WIDTH_ADJ = "/apps/x-tile/%s/width_adj"
GCONF_HEIGHT_ADJ = "/apps/x-tile/%s/height_adj"
GCONF_X1 = "/apps/x-tile/%s/x_1"
GCONF_Y1 = "/apps/x-tile/%s/y_1"
GCONF_W1 = "/apps/x-tile/%s/w_1"
GCONF_H1 = "/apps/x-tile/%s/h_1"
GCONF_X2 = "/apps/x-tile/%s/x_2"
GCONF_Y2 = "/apps/x-tile/%s/y_2"
GCONF_W2 = "/apps/x-tile/%s/w_2"
GCONF_H2 = "/apps/x-tile/%s/h_2"
GCONF_OVERRIDE_1 = "/apps/x-tile/%s/override_1"
GCONF_OVERRIDE_2 = "/apps/x-tile/%s/override_2"

UI_INFO = """
<ui>
   <menubar name='MenuBar'>
      <menu action='FileMenu'>
         <menuitem action='Filter'/>
         <menuitem action='Reload'/>
         <separator/>
         <menuitem action='QuitApp'/>
      </menu>
      
      <menu action='EditMenu'>
         <menuitem action='Preferences'/>
         <separator/>
         <menuitem action='SelectAll'/>
         <menuitem action='DeselectAll'/>
         <separator/>
         <menuitem action='Vertically'/>
         <menuitem action='Horizontally'/>
         <menuitem action='TriangleUp'/>
         <menuitem action='TriangleDown'/>
         <menuitem action='TriangleLeft'/>
         <menuitem action='TriangleRight'/>
         <menuitem action='Quad'/>
         <separator/>
         <menuitem action='Maximize'/>
         <menuitem action='Unmaximize'/>
         <menuitem action='Close'/>
      </menu>
      
      <menu action='RowMenu'>
         <menuitem action='RowUp'/>
         <menuitem action='RowDown'/>
         <separator/>
         <menuitem action='RowDelete'/>
      </menu>
      
      <menu action='ViewMenu'>
         <menuitem action='ShowHideVButtons'/>
         <menuitem action='ShowHideToolbar'/>
         <separator/>
         <menuitem action='IncreaseToolbarIconsSize'/>
         <menuitem action='DecreaseToolbarIconsSize'/>
      </menu>

      <menu action='HelpMenu'>
         <menuitem action='Help'/>
         <separator/>
         <menuitem action='About'/>
      </menu>
   </menubar>

   <toolbar name='ToolBar'>
      <toolitem action='SelectAll'/>
      <toolitem action='Reload'/>
      <separator/>
      <toolitem action='Vertically'/>
      <toolitem action='Horizontally'/>
      <toolitem action='TriangleUp'/>
      <toolitem action='TriangleDown'/>
      <toolitem action='TriangleLeft'/>
      <toolitem action='TriangleRight'/>
      <toolitem action='Quad'/>
      <separator/>
      <toolitem action='Maximize'/>
      <toolitem action='Unmaximize'/>
      <toolitem action='Close'/>
   </toolbar>
</ui>
"""

def get_entries(inst):
   """Returns the Menu Entries Given the Class Instance"""
   return [
   # name, stock id, label
   ( "FileMenu", None, _("_File") ),
   ( "EditMenu", None, _("_Edit") ),
   ( "RowMenu", None, _("_Row") ),
   ( "ViewMenu", None, _("_View") ),
   ( "HelpMenu", None, _("_Help") ),
   # name, stock id, label, accelerator, tooltip, callback
   ( "Filter", "gtk-properties", _("_Filter"), "<control>F", _("Filter Rows"), inst.dialog_filter),
   ( "Reload", "Reload Windows List", _("_Reload"), "F5", _("Reload the Windows List"), inst.reload_windows_list),
   ( "QuitApp", "gtk-quit", _("_Quit"), "<control>Q", _("Quit the Application"), inst.quit_application),
   ( "Preferences", "gtk-preferences", _("_Preferences"), "<control>P", _("Open the Preferences Window"), inst.dialog_preferences),
   ( "SelectAll", "Select All", _("Select _All"), "<control>A", _("Select All the Windows in the List"), inst.flag_all_rows),
   ( "DeselectAll", "Deselect All", _("Deselect A_ll"), "<control><shift>A", _("Deselect All the Windows in the List"), inst.unflag_all_rows),
   ( "Vertically", "Tile Vertically", _("Tile _Vertically"), "<control>V", _("Tile Vertically The Checked Windows"), inst.tile_vertically),
   ( "Horizontally", "Tile Horizontally", _("Tile _Horizontally"), "<control>H", _("Tile Horizontally The Checked Windows"), inst.tile_horizontally),
   ( "TriangleUp", "Tile Triangle Up", _("_Triangle Up"), "<control>Up", _("Tile Triangle Up The Checked Windows"), inst.tile_triangle_up),
   ( "TriangleDown", "Tile Triangle Down", _("Triangle _Down"), "<control>Down", _("Tile Triangle Down The Checked Windows"), inst.tile_triangle_down),
   ( "TriangleLeft", "Tile Triangle Left", _("Triangle _Left"), "<control>Left", _("Tile Triangle Left The Checked Windows"), inst.tile_triangle_left),
   ( "TriangleRight", "Tile Triangle Right", _("Triangle _Right"), "<control>Right", _("Tile Triangle Right The Checked Windows"), inst.tile_triangle_right),
   ( "Quad", "Tile Quad", _("Tile _Quad"), "<control>4", _("Tile into 4 quadrants The Checked Windows"), inst.tile_quad),
   ( "Maximize", "Maximize Windows", _("_Maximize Windows"), "<control>M", _("Maximize The Checked Windows"), inst.maximize_checked_windows),
   ( "Unmaximize", "Unmaximize Windows", _("_Unmaximize Windows"), "<control>U", _("Unmaximize The Checked Windows"), inst.unmaximize_checked_windows),
   ( "Close", "Close Windows", _("_Close Windows"), "<control>C", _("Close The Checked Windows"), inst.close_checked_windows),
   ( "RowUp", "gtk-go-up", _("Move _Up"), "<alt>Up", _("Move the Selected Row Up"), inst.on_button_row_up_clicked),
   ( "RowDown", "gtk-go-down", _("Move _Down"), "<alt>Down", _("Move the Selected Row Down"), inst.on_button_row_down_clicked),
   ( "RowDelete", "gtk-remove", _("_Remove"), "Delete", _("Remove the Selected Row"), inst.on_button_row_delete_clicked),
   ( "ShowHideVButtons", "VButtons", _("Show/Hide _Vertical Buttons"), None, _("Toggle Show/Hide Vertical Buttons"), inst.show_hide_vertical_buttons),
   ( "ShowHideToolbar", "Toolbar", _("Show/Hide _Toolbar"), None, _("Toggle Show/Hide Toolbar"), inst.show_hide_toolbar),
   ( "IncreaseToolbarIconsSize", "gtk-add", _("_Increase Toolbar Icons Size"), None, _("Increase the Size of the Toolbar Icons"), inst.toolbar_icons_size_increase),
   ( "DecreaseToolbarIconsSize", "gtk-remove", _("_Decrease Toolbar Icons Size"), None, _("Decrease the Size of the Toolbar Icons"), inst.toolbar_icons_size_decrease),
   ( "Help", "Help Contents", _("_Help"), None, _("X Tile Project Home Page"), inst.on_help_menu_item_activated),
   ( "About", "gtk-about", _("_About"), None, _("About X Tile"), inst.dialog_about),
   ]

APPLET_MENU_XML = '<popup name="button3">'\
         + '<menuitem name="About" verb="About" label="' + _("_About") + '" pixtype="stock" pixname="gtk-about"/>'\
         + '<menuitem name="All_M" verb="All_M" label="' + _("_Maximize All") + '" pixtype="stock" pixname="Maximize Windows"/>'\
         + '<menuitem name="All_4" verb="All_4" label="' + _("Tile All _Quad") + '" pixtype="stock" pixname="Tile Quad"/>'\
         + '<menuitem name="All_TR" verb="All_TR" label="' + _("Tile All Triangle _Right") + '" pixtype="stock" pixname="Tile Triangle Right"/>'\
         + '<menuitem name="All_TL" verb="All_TL" label="' + _("Tile All Triangle _Left") + '" pixtype="stock" pixname="Tile Triangle Left"/>'\
         + '<menuitem name="All_TD" verb="All_TD" label="' + _("Tile All Triangle _Down") + '" pixtype="stock" pixname="Tile Triangle Down"/>'\
         + '<menuitem name="All_TU" verb="All_TU" label="' + _("Tile All Triangle _Up") + '" pixtype="stock" pixname="Tile Triangle Up"/>'\
         + '<menuitem name="All_H" verb="All_H" label="' + _("Tile All _Horizontally") + '" pixtype="stock" pixname="Tile Horizontally"/>'\
         + '<menuitem name="All_V" verb="All_V" label="' + _("Tile All _Vertically") + '" pixtype="stock" pixname="Tile Vertically"/>'\
         +'</popup>'

def get_applet_menu_verbs(inst):
   """Returns the Menu Verbs Given the Class Instance"""
   return [("About", inst.dialog_about),
           ("All_M", inst.maximize_all),
           ("All_4", inst.tile_all_quad),
           ("All_TR", inst.tile_all_triangle_right),
           ("All_TL", inst.tile_all_triangle_left),
           ("All_TD", inst.tile_all_triangle_down),
           ("All_TU", inst.tile_all_triangle_up),
           ("All_H", inst.tile_all_horizontally),
           ("All_V", inst.tile_all_vertically)]

HELP_TEXT = """

NAME
   X Tile - Tile the Windows upon your Desktop

SYNOPSIS
   x-tile OPTION

DESCRIPTION
   This manual page briefly documents the command line arguments

OPTIONS

   --without-panel
      open the x-tile main window without using the panel

   --tile-all-vertically
      tile all opened windows vertically

   --tile-all-horizontally
      tile all opened windows horizontally

   --tile-all-triangle-up
      tile all opened windows triangle-up

   --tile-all-triangle-down
      tile all opened windows triangle-down

   --tile-all-triangle-left
      tile all opened windows triangle-left

   --tile-all-triangle-right
      tile all opened windows triangle-right

   --tile-all-quad
      quad tile all opened windows

   --maximize-all
      maximize all opened windows

SEE ALSO
   http://open.vitaminap.it/en/x_tile.htm

AUTHORS
   Giuseppe Penone and Chris Camacho

"""
